<?php

require 'conn.php';

if ($_SERVER["REQUEST_METHOD"] == "POST")
{
    $storePassword = $_POST['keyStorePassword'];
    $cn = $_POST['cn'];
    $ou = $_POST['ou'];
    $o = $_POST['o'];
    $l = $_POST['l'];
    $st = $_POST['st'];
    $c = $_POST['c'];


    // Fetch the latest entry from the database
    $sql = "SELECT app_logo,
                   app_name, splash_screen_text, website_url,
                   hdpi_standard_icon, hdpi_foreground_icon, hdpi_round_icon,
                   mdpi_standard_icon, mdpi_foreground_icon, mdpi_round_icon,
                   xhdpi_standard_icon, xhdpi_foreground_icon, xhdpi_round_icon,
                   xxhdpi_standard_icon, xxhdpi_foreground_icon, xxhdpi_round_icon,
                   xxxhdpi_standard_icon, xxxhdpi_foreground_icon, xxxhdpi_round_icon
            FROM app_details ORDER BY id DESC LIMIT 1";
    $result = $conn->query($sql);

    if ($result->num_rows > 0) {
        $row = $result->fetch_assoc();
        $app_logo_blob = $row['app_logo'];
        $app_name = $row['app_name'];
        $splash_screen_text = $row['splash_screen_text'];
        $website_url = $row['website_url'];
        $icons = [
            'hdpi' => [
                'standard' => $row['hdpi_standard_icon'],
                'foreground' => $row['hdpi_foreground_icon'],
                'round' => $row['hdpi_round_icon']
            ],
            'mdpi' => [
                'standard' => $row['mdpi_standard_icon'],
                'foreground' => $row['mdpi_foreground_icon'],
                'round' => $row['mdpi_round_icon']
            ],
            'xhdpi' => [
                'standard' => $row['xhdpi_standard_icon'],
                'foreground' => $row['xhdpi_foreground_icon'],
                'round' => $row['xhdpi_round_icon']
            ],
            'xxhdpi' => [
                'standard' => $row['xxhdpi_standard_icon'],
                'foreground' => $row['xxhdpi_foreground_icon'],
                'round' => $row['xxhdpi_round_icon']
            ],
            'xxxhdpi' => [
                'standard' => $row['xxxhdpi_standard_icon'],
                'foreground' => $row['xxxhdpi_foreground_icon'],
                'round' => $row['xxxhdpi_round_icon']
            ]
        ];
    } else {
        echo "No records found";
        exit;
    }

    $conn->close();

    // Paths
    $projectDir = 'C:/Users/Admin/AndroidStudioProjects/Automize_web_app';
    $playStoreLogoPath = $projectDir . '/app/src/main/ic_launcher-playstore.png';
    $stringsFilePath = $projectDir . '/app/src/main/res/values/strings.xml';

    // Save the BLOB data as a Playstore main PNG file
    if ($app_logo_blob != null) {
        file_put_contents($playStoreLogoPath, $app_logo_blob);
    }

    // Function to save icon images to the respective directories
    function saveIcon($iconBlob, $destPath) {
        if ($iconBlob != null) {
            file_put_contents($destPath, $iconBlob);
        }
    }

    // Paths to mipmap directories
    $mipmapDirs = [
        'hdpi' => $projectDir . '/app/src/main/res/mipmap-hdpi',
        'mdpi' => $projectDir . '/app/src/main/res/mipmap-mdpi',
        'xhdpi' => $projectDir . '/app/src/main/res/mipmap-xhdpi',
        'xxhdpi' => $projectDir . '/app/src/main/res/mipmap-xxhdpi',
        'xxxhdpi' => $projectDir . '/app/src/main/res/mipmap-xxxhdpi'
    ];

    // Save icons to their respective mipmap directories
    foreach ($mipmapDirs as $density => $dir) {
        if (!file_exists($dir)) {
            mkdir($dir, 0777, true);
        }
        saveIcon($icons[$density]['standard'], "$dir/ic_launcher.webp");
        saveIcon($icons[$density]['foreground'], "$dir/ic_launcher_foreground.webp");
        saveIcon($icons[$density]['round'], "$dir/ic_launcher_round.webp");
    }

    // Update the strings.xml
    $xml = simplexml_load_file($stringsFilePath);
    foreach ($xml->string as $string) {
        if ((string)$string['name'] === 'website_url') {
            $string[0] = $website_url;
        }
        if ((string)$string['name'] === 'app_name') {
            $string[0] = $app_name;
        }
        if ((string)$string['name'] === 'splash_screen_text') {
            $string[0] = $splash_screen_text;
        }
    }
    $xml->asXML($stringsFilePath);

    // Sanitize the app name for use in a filename
    function sanitizeFileName($filename) {
        return preg_replace('/[^a-zA-Z0-9 \-_]/', '', $filename);
    }

    $sanitized_app_name = sanitizeFileName($app_name);

    // Path to the script that automates the Android build process
    $build_script = 'update_assets_and_build.bat';

    // Run the batch script to build the project
    exec("cmd /c \"$build_script\" $storePassword $cn $ou $o $l $st $c", $output, $return_var);


    file_put_contents('C:/xampp/htdocs/Automizing_Web_App_logo/build_log.txt', implode("\n", $output));

    if ($return_var === 0) {
        echo $app_name;
       // Paths for .apk and .aab files
        $apk_filename = $projectDir . '/app/build/outputs/apk/release/app-release.apk';
        $aab_filename = $projectDir . '/app/build/outputs/bundle/release/app-release.aab';

        if (file_exists($apk_filename)) {
            $download_filename_apk = $sanitized_app_name . '-app.apk';
            header('Content-Type: application/vnd.android.package-archive');
            header('Content-Disposition: attachment; filename='. $download_filename_apk);
            header('Content-Length: ' . filesize($apk_filename));
            ob_end_flush();
            readfile($apk_filename);
            exit;
        } else {
            echo "APK file not found.";
        }

        if (file_exists($aab_filename)) {
            $download_filename_aab = $sanitized_app_name . '-app.aab';
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename='. $download_filename_aab);
            header('Content-Length: ' . filesize($aab_filename));
            ob_end_flush();
            readfile($aab_filename);
            exit;
        } else {
            echo "AAB file not found.";
        }
    } else {
        echo "Error: Build process failed. Please check the server logs for details.".$return_var;
    }
}
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Build Android App</title>
</head>
<body>
    <h3>NO SPACE PLEASE</h3>
    <form method="post">

        <label for="keyPassword">Key Store Password:</label>
        <input type="password" id="keyStorePassword" name="keyStorePassword" required><br>

        <label for="cn">Your Full Name (CN):</label>
        <input type="text" id="cn" name="cn" required><br>

        <label for="ou">Your Organizational Unit (OU):</label>
        <input type="text" id="ou" name="ou" required><br>

        <label for="o">Your Organization (O):</label>
        <input type="text" id="o" name="o" required><br>

        <label for="l">Your City or Locality (L):</label>
        <input type="text" id="l" name="l" required><br>

        <label for="st">Your State or Province (ST):</label>
        <input type="text" id="st" name="st" required><br>

        <label for="c">Your Country Code (C):</label>
        <input type="text" id="c" name="c" required><br>

        <input type="submit" value="Build App">
    </form>
</body>
</html>
